#!/usr/bin/perl -w

#
#       multi.pl - Test the cardreader module
#       Ludovic Rousseau
# lun avr 24 00:24:03 CEST 2000
#       

# $test_limit = 1
# The program will allocate as many reader as it can.
# It will exhaust the system resources "Too many open files".

# $test_limit = 0;
# the program will allocate/deallocate for ever.

use strict;
use cardreader;

my ($scr, $i, @list);
my ($test_limit);

$test_limit = 1;

$i=0;
while (1)
{
	$scr = new cardreader or die "Can't allocate reader: $!\n";
	print $scr -> ResetCard;
	print " $i $scr\n";
	$scr -> PowerDown;
	$i++;
	if ($test_limit)
	{
		push @list, $scr;
	}
	else
	{
		undef $scr;
	}
}

