#!/usr/bin/perl -w

#
#	server.pl - communicate to the card through a TCP/IP socket
#	Ludovic Rousseau
#	mar avr 25 00:31:35 CEST 2000
#	

use strict;
use IO::Socket;
use cardreader;

require 'sc_shell.pl';

my ($SERVER_PORT);

$SERVER_PORT = 6970;

# main loop
my ($server, $client, $client_address, $scr);

$scr = new cardreader or die "Can't allocate reader: $!\n";

$server = IO::Socket::INET -> new (LocalPort => $SERVER_PORT,
		Type => SOCK_STREAM,
		Reuse => 1,
		Listen => 10)
	or die "IO::Socket::INET port $SERVER_PORT: $!";

#####################################################################
#																	#
#						boucle principale 							#
#																	#
#####################################################################
while (($client, $client_address) = $server -> accept())
{
	# $client is the new connection

	my ($port, $iaddr) = unpack_sockaddr_in($client_address);
	my ($line, $ret);

	sc_shell($scr, $client, $client, 0);
}

# should never occur
close($server);

# The End
exit;

