<html>
<head><title>Smart Card Reader</title></head>
<body>

<%

#
#	webscreader.asp - Apache::ASP interface to a smart card reader
# 	Ludovic Rousseau
#	mar mai  2 23:58:40 CEST 2000
#

#	This code is still VERY buggy
#	Use with care

#	you must run ./server.pl first. This ASP script uses it to
#	communicate with the Smart Card reader

use IO::Socket;
use IO::Select;

$SERVER_PORT = 6970;
$SERVER_ADDR = "127.0.0.1";

@log = @{$Session -> {log}};
@log = () if (! defined @log);

# process form here
$form = $Request -> Form();
if ($form -> {reset})
{
	send_command("R\n");
}

if($form -> {SendIncomingAPDU})
{
	send_command("I" . $form->{SendIncomingAPDU} . "\n");
}

if($form -> {SendOutgoingAPDU})
{
	send_command("O" . $form->{SendOutgoingAPDU} . "\n");
}

if ($form -> {clear})
{
	@log = ();
}

if ($form -> {powerdown})
{
	send_command("P\n");
}

if ($form -> {resetstate})
{
	close $socket;
	undef $socket;
	@log = ();
	%{$Session} = ();
}

sub add_log
{
	my $line = shift;

	$line = localtime() . ": " . $line;
	unshift @log, ($line);
}

sub send_command
{
	my $command = shift;
	my $res;

	# open the connection
	if (! defined $socket)
	{
		$socket = IO::Socket::INET->new(
			PeerAddr => $SERVER_ADDR,
			PeerPort => $SERVER_PORT,
			Proto => 'tcp',
			Type => SOCK_STREAM);
	}

	add_log "=>$command";

	if (! defined $socket)
	{
		add_log "Couldn't connect to $SERVER_ADDR port $SERVER_PORT: $@\n";
	}
	else
	{
		# sends the command
		print $socket $command;

		# block on the first line
		$res = <$socket>;
		add_log $res;

		# non blocking reading
		$sel = new IO::Select($socket);

		while ($sel->can_read(0.1))
		{
			$res = <$socket>;
			last if (!defined $res);
			add_log $res;
		}

	close $socket;
	undef $socket;
	}
}

%>

<h1>Smart Card Web interface</h1>

Author: Ludovic Rousseau, Tue May 2 2000

<table>
<form action="<%=$Request->ServerVariables("SCRIPT_NAME")%>" method=POST>

<tr>
	<input type=submit name=reset value="Reset Card">
	<input type=submit name=clear value="Clear">
	<input type=submit name=powerdown value="PowerDown">
	<input type=submit name=resetstate value="Reset State">
	<input type=submit name=redraw value="Redraw">
	
<tr>
	<td><input name=SendIncomingAPDU type=text size=40 value="" >
	</td>
	<td><input type=submit value="Send Incoming APDU"></td>
	
<tr>
	<td><input name=SendOutgoingAPDU type=text size=40 value="" >
	</td>
	<td><input type=submit value="Send Outgoing APDU"></td>
	
<tr>
	<td><input name=SendIncomingOutgoingAPDU type=text size=40 value="" >
	</td>
	<td><input type=submit value="Send IncomingOutgoing APDU"></td>
</tr>
</table>

<pre>
<%
foreach (@log)
{
	print "$_";
}

$Session -> {log} = \@log;

%>
</pre>

<p>

</body>
</html>

