# Before `make install' is performed this script should be runnable with
# `make test'. After `make install' it should work as `perl test.pl'

######################### We start with some black magic to print on failure.

my ($scr, $def_device, $device, $reader_type, $scr2);

BEGIN { $| = 1; print "1..4\n"; }
END {print "not ok 1\n" unless $loaded;}

use cardreader;
$loaded = 1;
print "ok $loaded\n";

######################### End of black magic.

# Insert your test code below (better if it prints "ok 13"
# (correspondingly "not ok 13") depending on the success of chunk 13
# of the test code):

# Get the device string
$def_device = "/dev/screader";
$def_device = "COM1" if ($^O eq "MSWin32");

print STDERR "\nEnter the device [" . $def_device . "]: ";
chomp($device = <STDIN>);
$device = $def_device if ($device eq "");

# Get the reader type
print STDERR "Enter the reader type (TLP,RFTLP) [TLP]: ";
chomp($reader_type = <STDIN>);
$reader_type = "TLP" if ($reader_type eq "");

$loaded = 2;
$scr = new cardreader($reader_type, $device);
if (! defined $scr)
{
	print "not ";
	print STDERR "new $!\n";
}
print "ok $loaded\n";

$loaded = 3;
$ret = $scr -> ResetCard;
if ($ret eq "")
{
	print "not ";
	print STDERR "ResetCard $!\n";
}
print "ok $loaded\n";

$loaded = 4;
$ret = $scr -> PowerDown;
if (!$ret)
{
	print "not ";
	print STDERR "PowerDown $!\n";
}
print "ok $loaded\n";

undef $scr;

